//+------------------------------------------------------------------+
//|                                                     SubChart.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 DimGray
#property indicator_color2 DimGray
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_color5 PaleVioletRed
#property indicator_color6 DeepSkyBlue
#property indicator_color7 DimGray
#property indicator_width5 2
#property indicator_width6 2
#property indicator_style7 STYLE_DOT

//
//
//
//
//

extern string    TimeFrame        = "Current time frame";
extern int       EmaPeriod        = 13;
extern int       MacdFastPeriod   = 12;
extern int       MacdSlowPeriod   = 26;
extern int       MacdSignalPeriod =  9;
extern int       Price            = PRICE_CLOSE;
extern string    ForSymbol        = "";
extern string    UniqueID         = "1";
extern int       FromRight        = 110;
extern int       Width            = 130;
extern bool      UpperHalf        = false;
extern color     FrameColor       = DimGray;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double impulseDn[];
double impulseUp[];
double trend[];

string indicatorFileName;
bool   calculateValue;
int    timeFrame;
string forSymbol;
string title;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,buffer1);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer3);   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,buffer4);   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,impulseDn); SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(5,impulseUp); SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexBuffer(6,buffer5);
   SetIndexBuffer(7,trend);

   //
   //
   //
   //
   //
   
   forSymbol = ForSymbol;
   if (forSymbol == "")
       forSymbol = Symbol(); 
       forSymbol = stringUpperCase(forSymbol);
          if (iClose(forSymbol,timeFrame,0) == 0) forSymbol = Symbol();
          
   //
   //
   //
   //
                      
      indicatorFileName = WindowExpertName();
      calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
      timeFrame         = stringToTimeFrame(TimeFrame);

   //
   //
   //
   //
   //
   
   title     = forSymbol+" - "+timeFrameToString(timeFrame);
   return(0);
}

//
//
//
//
//

int deinit()
{
   switch(UninitializeReason())
   {
        case REASON_RECOMPILE:
        case REASON_PARAMETERS:
        case REASON_ACCOUNT:
             break;
        case REASON_REMOVE:
        case REASON_CHARTCHANGE:
        case REASON_CHARTCLOSE:
             ObjectDelete(UniqueID);
             ObjectDelete(UniqueID+"frame");
             break;
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

double work[][4];
#define _ema   0
#define _macdv 1
#define _macds 2
#define _macdo 3

//
//
//
//
//

int start()
{
   if (calculateValue)
   {
      double alpha = 2.0 / (1.0+MacdSignalPeriod);
      int i,r,limit,counted_bars=IndicatorCounted();
   
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
              limit=MathMin(Bars-counted_bars,Bars-1);
   
              if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
               
      //
      //
      //
      //
      //
                     
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][_ema]   = iMA(NULL,0,EmaPeriod,0,MODE_EMA,Price,i); 
         work[r][_macdv] = iMA(NULL,0,MacdFastPeriod,0,MODE_EMA,Price,i)-iMA(NULL,0,MacdSlowPeriod,0,MODE_EMA,Price,i);
         work[r][_macds] = work[r-1][_macds]+alpha*(work[r][_macdv]-work[r-1][_macds]);
         work[r][_macdo] = work[r][_macdv]-work[r][_macds];
       
         //
         //
         //
         //
         //
         
         impulseDn[i]=EMPTY_VALUE;
         impulseUp[i]=EMPTY_VALUE;
         trend[i]    =EMPTY_VALUE;
            double cOpen  = Open[i];
            double cClose = Close[i];
         if (work[r][_ema]<work[r-1][_ema] && work[r][_macdo]<work[r-1][_macdo]) trend[i] = -1;
         if (work[r][_ema]>work[r-1][_ema] && work[r][_macdo]>work[r-1][_macdo]) trend[i] =  1;
      }
      return(0);
   }     

   //
   //
   //
   //
   //
   
   double maxValue = iHigh(forSymbol,timeFrame,iHighest(forSymbol,timeFrame,MODE_HIGH,Width-2,0));
   double minValue =  iLow(forSymbol,timeFrame, iLowest(forSymbol,timeFrame,MODE_LOW ,Width-2,0));
   double range    = maxValue-minValue;
   
   //
   //
   //
   //
   //
   
   double high;
   double low;
      checkFrame(high,low);
         SetIndexShift(0,-(FromRight+1)); 
         SetIndexShift(1,-(FromRight+1)); 
         SetIndexShift(2,-(FromRight+1)); 
         SetIndexShift(3,-(FromRight+1)); 
         SetIndexShift(4,-(FromRight+1));
         SetIndexShift(5,-(FromRight+1));
         SetIndexShift(6,-(FromRight+1));
      
      //
      //
      //
      //
      //
      
      double coef = (high-low)/range;
      for (i=0; i<Width-1; i++)
      {
         double priceO =  iOpen(forSymbol,timeFrame,i);
         double priceC = iClose(forSymbol,timeFrame,i);
         double priceH =  iHigh(forSymbol,timeFrame,i);
         double priceL =   iLow(forSymbol,timeFrame,i);
            buffer1[i] = low+(priceH-minValue)*coef;
            buffer2[i] = low+(priceL-minValue)*coef;
            buffer3[i] = low+(priceO-minValue)*coef;
            buffer4[i] = low+(priceC-minValue)*coef;
            buffer5[i] = buffer4[0];

            //
            //
            //
            //
            //
            
            trend[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",EmaPeriod,MacdFastPeriod,MacdSlowPeriod,MacdSignalPeriod,Price,7,i);
            impulseDn[i] = EMPTY_VALUE;
            impulseUp[i] = EMPTY_VALUE;

            if (trend[i] == -1) { impulseDn[i]=MathMax(buffer3[i],buffer4[i]); impulseUp[i]=MathMin(buffer3[i],buffer4[i]); }       
            if (trend[i] ==  1) { impulseDn[i]=MathMin(buffer3[i],buffer4[i]); impulseUp[i]=MathMax(buffer3[i],buffer4[i]); }
      }
      while(i < Bars && buffer1[i] != EMPTY_VALUE)
      {
            buffer1[i]   = EMPTY_VALUE;
            buffer2[i]   = EMPTY_VALUE;
            buffer3[i]   = EMPTY_VALUE;
            buffer4[i]   = EMPTY_VALUE;
            buffer5[i]   = EMPTY_VALUE;
            impulseDn[i] = EMPTY_VALUE;
            impulseUp[i] = EMPTY_VALUE;
            i++;
      }
   return(0);
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

void checkFrame(double& high, double& low)
{
   string name = UniqueID+"frame";
          
   //
   //
   //
   //
   //
     
   int firstBar = MathMin(WindowFirstVisibleBar(),WindowBarsPerChart());
   if (UpperHalf)
   {      
      high = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,firstBar,0))-Point;
      low  = (iLow(NULL,0,iLowest (NULL,0,MODE_LOW ,firstBar,0))+high)/2+Point;
   }
   else
   {
      low  =   iLow(NULL,0, iLowest(NULL,0,MODE_LOW ,firstBar,0))+Point;
      high = (iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,firstBar,0))+low)/2-Point;
   }      
      if (ObjectFind(name) == -1)
         {
            ObjectCreate(name,OBJ_RECTANGLE,0,0,0,0,0);
               ObjectSet(name,OBJPROP_COLOR,FrameColor);
               ObjectSet(name,OBJPROP_BACK,false);
         }     
   
      //
      //
      //
      //
      //
      
      datetime rightBorder = Time[FromRight];
      datetime leftBorder  = Time[FromRight+Width];
      if (FromRight<0)
      {
         rightBorder = Time[0]-Period()*60*FromRight;
         if ((FromRight+Width) > 0)
               leftBorder = Time[FromRight+Width];
         else  leftBorder = Time[0]-Period()*60*(FromRight+Width);
      }
      else
      {
         ObjectSet(name,OBJPROP_TIME1,Time[FromRight]);
         ObjectSet(name,OBJPROP_TIME2,Time[FromRight+Width]);
      }      

   //
   //
   //
   //
   //
   
      ObjectSet(name,OBJPROP_TIME1,rightBorder);
      ObjectSet(name,OBJPROP_TIME2,leftBorder);
      ObjectSet(name,OBJPROP_PRICE1,high+Point);
      ObjectSet(name,OBJPROP_PRICE2,low -Point);

   //
   //
   //
   //
   //
   
   name = UniqueID;
      if (ObjectFind(name) == -1)
               ObjectCreate(name,OBJ_TEXT,0,0,0);
               ObjectSet(name,OBJPROP_TIME1,rightBorder-Width/2*Period()*60);
               ObjectSet(name,OBJPROP_PRICE1,high);
               ObjectSetText(name,title+" : "+DoubleToStr(iClose(forSymbol,timeFrame,0),MarketInfo(forSymbol,MODE_DIGITS)),10,"Arial bold",YellowGreen);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(iTfTable[i]);
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}